typedef struct priqueue;

//typedef union {
//  struct priqueue *ptr;
//  int index;
//} qPtr;

typedef struct priqueue {
  //  qPtr prev;
  //  qPtr next;
  struct priqueue *prev;
  struct priqueue *next;
  unsigned long priority;
} PriorityQueueMember;

/* here's the queue as a whole */
typedef struct pqueue {
    PriorityQueueMember *list;
} PriorityQueue;

void *         QInitMem(void *mem, unsigned num_elems, unsigned size_elems);
void           QInit_func(PriorityQueue *queue, PriorityQueueMember *initialmem);

void           QAdd(PriorityQueue *queue, PriorityQueueMember *member, int comparison);
int            QRemove(PriorityQueue *queue, PriorityQueueMember *member);
PriorityQueueMember * QGetHead(PriorityQueue *queue);
void           QPutHead(PriorityQueue *queue, PriorityQueueMember *m);
int            QIsEmpty(PriorityQueue *q);

#define QInit(queue, initial)\
    queue->list = initial;

/* priority macros */
#define ComparePriorities(a,b) ((long)((a) - (b)))
#define LowerPriority(a,b) (ComparePriorities(a,b) > 0)
#define LowerOrEqualPriority(a,b) (ComparePriorities(a,b) >= 0)
#define HigherPriority(a,b) (ComparePriorities(a,b) < 0)
#define HigherOrEqualPriority(a,b) (ComparePriorities(a,b) <= 0)
