SCRNWIDTH = 360
DMA_READ_BIT    = (1<<13)
DMA_PIXEL_WRITE = (3<<14)
DMA_PIXEL_READ  = (DMA_PIXEL_WRITE|DMA_READ_BIT)
DMAFLAGS   = (DMA_PIXEL_WRITE | ((SCRNWIDTH/8)<<16) | (4<<4) | (1<<11))
DMAFLAGS16 = (DMA_PIXEL_READ  | ((16/8)       <<16) | (4<<4) | (1<<11))

	kOneShotBit = 0
	kSlicedBit  = 1
	kClearBit   = 2

		.segment sprited
		.origin 0x20100000

_SpriteBase::		
_base:
ctr:
init_env:
 	.dc.s	0
mpenum:
 	.dc.s	0
memstat:
 	.dc.s	0
mpeinfo:
 	.dc.s	0
dest_screen:
  	.dc.s	DMAFLAGS			; dmaflags destination
dest:
 	.dc.s	$40000000	; dest screen
xclip:	
	.dc.s	$01670000	; clipping xmax/xmin 
yclip:
	.dc.s	$00ef0000   ; clipping ymax/ymin
sprbase:
	.dc.s	0
//flags:    
//    .dc.s   0

//	.align.v
//    .dc.s   0			; dummy
qinf:
    .dc.s   0           ; next object
    .dc.s   0           ; depth
    .dc.s   0           ; parent list
object:                         ;this has to be vector aligned!!!
	.dc.s	$00b40078   		;packed 16bit x:y destination position
	.dc.s	$00100010	 	;size X:Y 
	.dc.s	$00100000		;source page offset (16:16, x)
	.dc.s	$00100000		;source page offset (16:16, y)

	.dc.s	$00060000		;X scale (16:16)
	.dc.s	$00060000		;Y scale (16:16)
	.dc.s	$00001658		;Rotate angle (16:16)
	.dc.s	$40000002		;Translucency/Mix  (2:30)

;    .dc.s   DMAFLAGS16		    ;DMA flags sprite source 
;	.dc.s	testsprite		;sprite source
	.dc.s   DMAFLAGS|(1<<13)	;DMA flags sprite source 
	.dc.s	$40000000		;sprite source
	.dc.s	$00808000		;transparent pixel value
	.dc.s	$10808000	    	;target value for tint
					   
	.dc.s   0		  	
	.dc.s   0
	.dc.s   0

//nextObject:			
//	.ds.s	20

//lastObject:
//	.dc.s	0
	
ob_type:
	.dc.s	0	;indicates math table and code needed for overlay( not needed here)

// SDC 2002-09-16: Removed unused data & labels
//lstac:
//	.ds.s	16
	
dma__cmd:
	.ds.s	8
	
// SDC 2002-09-16: Removed unused data & labels
// Added back in since it seems to need it (??)
ol_buffer:
	.ds.s	24
	
RecipLUT:
	.include "_reciplut.i"
	
// SDC 2002-09-16: Removed unused data & labels
//SineLUT:
//	.include "_sinelut.i"
//RSqrtLUT:
	
dest_read:
	.ds.b 	512
buffy:
source_tile:
	.ds.b 	1088
dma__cmd2:
	.ds.s	8
dma__cmd3:
	.ds.s	8
CommRecvPoi:
    .dc.s   CommRecv

dmawaitcnt:
	.dc.s	0
    
		.segment spritec
		.origin 0x20300000

	_ymin = r14
	_ymax = r15
	_slices = r16
	_zonelo = r17
	_zonehi = r18

//	st_s	#(16<<24)|(0<<16)|(2<<8)|(1<<kClearBit),mpeinfo
//	st_s	#(16<<24)|(0<<16)|(2<<8)|(1<<kClearBit),flags
//	mv_s	#0x9FB86D00,r19
//	jmp	SkipCommBus,nop
	
	ld_s    configa,r0		    
	nop
	bits    #7,>>#8,r0
    bra     ne,`notMPE0,nop    
`MPE0:    
    ld_io	intvec1,r0
 	nop
 	sub	    #8,r0
 	st_s    r0,CommRecvPoi
    bra     main,nop

`notMPE0:	
	st_s	#0x20101000,sp
    mv_s    #CommRecv,r0
    st_s    r0,CommRecvPoi
    
main:    

    ld_s   CommRecvPoi,r0
    nop
    jsr     (r0),nop
    mv_v    v0,v4    
//    st_s    r18,flags
// SDC 2002-08-24: Rearranged comm bus packet
//    st_s    r19,mpeinfo
    st_s    r18,mpeinfo

    jsr     dma_read
    {
// SDC 2002-08-29: Added sprite base to raster info
    mv_s    #5,r0       ; raster info size 16 bytes
    copy    r16,r1      ; r16 = commpacket[0]
    }
    mv_s    #dest_screen,r2
    jsr     dma_finished,nop

SkipCommBus:
//	ld_s	flags,r0
	ld_s	mpeinfo,r0
	nop
	btst	#kClearBit,r0
	jsr	ne,ClearScreen,nop

; firstObj:
; 	st_s	#0,lastObject
; 	jsr     dma_read	; Get first object
; {	mv_s    #16,r0		; object size 64 bytes
; 	copy    r17,r1		; r17 = commpacket[1]
; }
; {	mv_s    #nextObject,r2
; 	add	#4,r1		; Skip past "prev"
; }
	
; 	jsr     dma_wait,nop	; Wait for DMA to be free
	
nextObj:        
    jsr     dma_read
    {
    mv_s    #16,r0
    copy    r17,r1      ; r17 = commpacket[1]
    }
{    mv_s    #qinf,r2
 	add	#4,r1		; Skip past "prev"
}

	jsr	dma_finished,nop
//	ld_s	dmawaitcnt,r1
//`mdma_finished:
//	ld_s	odmactl,r0
//	add	#1,r1
//	bits	#4,>>#0,r0
//	bra	ne,`mdma_finished,nop
//	st_s	r1,dmawaitcnt
	
; 	cmp	#0,r17
; 	bra	ne,notLast,nop
; 	st_s	#1,lastObject
; 	bra	skipLoad
; notLast:
; 	jsr     dma_read
; {	mv_s    #16,r0      ; object size 64 bytes
; 	copy    r17,r1      ; r17 = commpacket[1]
; }
; {	mv_s    #nextObject,r2
; 	add	#4,r1		; Skip past "prev"
; }
; 	jsr     dma_wait,nop
; skipLoad:

; 	;; Copy the pre-loaded object info to the active object structure
; 	st_s	#15,rc0
; 	mv_s	#nextObject,r0
; 	mv_s	#qinf,r1
; copyObjLoop:
; 	ld_s	(r0),r2
; 	nop
; 	st_s	r2,(r1)
; 	dec	rc0
; 	bra	c0ne,copyObjLoop,nop
	

	ld_s	yclip,_ymin	;pickup the Y clip params
	nop
	lsr	    #16,_ymin,_ymax			;extract max-Y
	bits	#15,>>#0,_ymin		;and minimum

; do multiple MPE code

	mv_s	#0,_slices			;slice counter

slic:


// SDC 2002-08-24: Rearranged comm bus packet
//	ld_s	flags,r1		;get slice size
	ld_s	mpeinfo,r1		;get slice size
	ld_s	mpeinfo,r2	    ;get our logical mpe#
//	lsr     #16,r1
	lsr     #24,r1
	copy    r2,r3
//	bits    #15,>>#0,r3	;total # of mpes
//	lsr     #16,r2          ;logical mpe#
	bits    #7,>>#8,r3	;total # of mpes
	bits    #7,>>#16,r2          ;logical mpe#

	
	mul	r1,r2,>>#0,r2		;this is the base offset
	mul	r1,r3,>>#0,r3		;this is the chunk size
	nop

; start line of render zone is (chunk offset*slice number)+base offset

	mul	_slices,r3,>>#0,r3
	nop
	add	r3,r2,_zonelo
	add	_zonelo,r1,_zonehi				;get lo and hi edges of current zone
	sub	#1,_zonehi                   ;clip is inclusive

	cmp	_zonelo,_ymax
	bra	lt,restore_yclip				;start>hibound; the object's done

	cmp	_zonehi,_ymin
	bra	gt,next_zone		;end<lobound; do next zone

; preserve the original y clip info before I mod it

	push	v3				;save original Y-clip info

	cmp	_zonelo,_ymin
	bra	gt,nboto,nop			;if Ymin > Zonelo, then use Ymin...	
	copy _zonelo,_ymin			;else, just use zonelo.		

nboto:

	cmp	_zonehi,_ymax
	bra	lt,ntopo,nop			;if Ymax < Zonehi then use Ymax
	copy _zonehi,_ymax			;or else use zonehi.

ntopo:

; now, set _ymin and _ymax to be the Y clip params

	lsl	#16,_ymax
	or _ymax,_ymin
	st_s	_ymin,yclip 	;set them up

; now draw ... !
    push    v4
    jsr		draw_sprite,nop
    pop     v4
next_zone:	

	bra slic	;go to next slice
	pop	v3			;get back y-clip stuff too
	add	#1,_slices	;enumerate next slice	

restore_yclip:

; restore yclip modified by subdivision

	lsl	#16,_ymax
	or _ymax,_ymin
	st_s	_ymin,yclip	;set them up

//    ld_s    flags,r18
	
//	ld_s	lastObject,r0		; Check flag that says we are done
	ld_s    mpeinfo,r18
	ld_s    qinf,r17
	btst    #kOneShotBit,r18
	bra     ne,`onshot,nop
//	cmp	#1,r0			; Was that the last object?
//	bra	ne,nextObj		; Nope, go back for more
	or      r17,r17
	bra     ne,nextObj,nop
`onshot:
//	ld_s	dmawaitcnt,r0
//	halt

    sub_sv     v0,v0
    mv_s    #0xbaaababe,r0
    jsr     CommSend
    mv_s    #3,r4
    mv_s    #0,r5
    
    bra     main
	nop
	nop

CommRecv:
    ld_s    commctl,r4
    nop
    btst    #31,r4
    bra     eq,CommRecv,nop
    ld_s    comminfo,r5
    ld_v    commrecv,v0
    rts
    bits    #7,>>#16,r4
    bits    #7,>>#16,r5

CommSend:
`1:
        ld_s   (commctl),r6             ; poll for transmit data empty
        nop
        btst    #15,r6                  ; ready to send?
        bra     ne,CommSend,nop        ; no -- keep waiting

`resend:

{       st_s    r5,comminfo
	bits	#8,>>#0,r4		; isolate just the address
}
        st_s    r4,commctl
        ; write to the transmit data register and so start transfer
        st_v    v0,commxmit


`waitxmit:
        ; now wait for the data to go
        ld_io   commctl,r6
        nop
        btst    #14,r6                  ; check for transmit failure
{       bra     ne,`resend,nop          ; failed -- retry
        btst    #5,r6                   ; check for transmit failure during interrupt
}
{       bra     ne,`resend,nop          ; failed -- retry
        btst    #15,r6                  ; check for transmit buffer empty
}
        rts     eq                      ; if it's empty, return
        bra     `waitxmit
        nop
        nop

	;; =================
	hRemaining_r4	= r4
	finalY_r5	= r5
	wRemaining_r6	= r6
	clipH_r7	= r7
	xCur_r8		= r8
	yCur_r9		= r9
	wCur_r10	= r10
	hCur_r11	= r11
	tmp_r12		= r12
	;; =================
ClearScreen:
	push	v0,rz

//	ld_s	flags,r1
	ld_s	mpeinfo,r1
	ld_s	mpeinfo,r2		; get our logical mpe#
	lsr	#24,r1			; get slice size
	copy	r2,r3
	bits	#7,>>#8,r3		; total # of mpes
	bits	#7,>>#16,r2		; logical mpe#

	mul	r1,r2,>>#0,r2		;this is the base offset
	mul	r1,r3,>>#0,r3		;this is the chunk size
	nop

	ld_s	dest_screen,tmp_r12	; Get DMA flags for the frame buffer
	nop
	or	#(1<<27),tmp_r12
	st_s	tmp_r12,dma__cmd+0

	ld_s	dest,tmp_r12		; Address of frame buffer
	nop
	st_s	tmp_r12,dma__cmd+4

	st_s	r19,dma__cmd+16		; Store the color in the direct data
	
	ld_s	yclip,finalY_r5
	nop
	lsr	#16,finalY_r5		; Get Y coord of end of clipping region

	ld_s	yclip,yCur_r9
	nop
	and	#$FFFF,yCur_r9		; Initialize current Y coord
	add	r2,yCur_r9		; Add offset for this MPE

	mv_s	r1,hRemaining_r4	; Initialize number of lines to transmit

	jmp	firstSlice,nop

nextSlice:
	add	r3,yCur_r9		; Go to end of next slice
	sub	r1,yCur_r9		; Back up to beginning of next slice
	
	add	r3,r2			; Get next starting Y coord
	cmp	finalY_r5,r2		; Are we done?
	jmp	gt,done,nop

	sub	r2,finalY_r5,tmp_r12	; Check if this isn't a full-height slice
	add	#1,tmp_r12
	cmp	hRemaining_r4,tmp_r12
	jmp	ge,gotSlice
	mv_s	r1,hRemaining_r4	; Initialize number of lines to transmit
	nop
	mv_s	tmp_r12,hRemaining_r4
gotSlice:

firstSlice:
	
nextBlockVert:
	cmp	#8,hRemaining_r4
	jmp	ge,gotHeight
	mv_s	#8,hCur_r11		; Assume 8 pixels
	nop
	copy	hRemaining_r4,hCur_r11	; Nope, was not 8, clamp
gotHeight:

	ld_s	xclip,tmp_r12
	nop
	lsr	#16,tmp_r12,wRemaining_r6
	and	#$FFFF,tmp_r12
	sub	tmp_r12,wRemaining_r6	; Get width in pixels
	add	#1,wRemaining_r6

	ld_s	xclip,xCur_r8
	nop
	and	#$FFFF,xCur_r8		; Initialize current X coord

nextBlockHoriz:
	cmp	#8,wRemaining_r6	; Check if rest of width is less than 8
	jmp	ge,gotWidth
	mv_s	#8,wCur_r10
	nop
	copy	wRemaining_r6,wCur_r10
gotWidth:

	lsl	#16,wCur_r10,tmp_r12	; Construct the X pos and W
	add	xCur_r8,tmp_r12
	st_s	tmp_r12,dma__cmd+8

	lsl	#16,hCur_r11,tmp_r12	; Construct the Y pos and H
	add	yCur_r9,tmp_r12
	st_s	tmp_r12,dma__cmd+12

	st_s	#dma__cmd,mdmacptr	; Start the DMA
	
	jsr     dma_wait,nop

	add	wCur_r10,xCur_r8
	sub	wCur_r10,wRemaining_r6
	jmp	gt,nextBlockHoriz,nop
	
	add	hCur_r11,yCur_r9
	sub	hCur_r11,hRemaining_r4
	jmp	gt,nextBlockVert,nop

	jmp	nextSlice,nop

done:
	jsr     dma_finished,nop

	pop	v0,rz
	nop
	rts
	nop
	nop
	
	.include "ldma.s"
	.include "ol_sprite.s"
    
