#include <stdio.h>
#include "sprite.h"
#include <nuon/termemu.h>
#include <nuon/bios.h>
#include <nuon/dma.h>
#include <nuon/video.h>

#define SCREEN_WIDTH 360
#define SCREEN_HEIGHT 240
#define DMAFLAGS  (DMA_PIXEL_WRITE | ((SCREEN_WIDTH/8)<<16) | (4<<4) | (1<<11))                                          

extern char SpriteImage[];

void *FrameBuffer[2];

int main()
{
    SPR_IMAGE_INFO img;
    SPRITE *sprite;
    SPRITE *sprite2,*sprite3,*sprite4,*sprite5;
    int angle,angle2,scale,i,f,a,c,x,y,ix,iy,ia,b;
	VidDisplay display;
	VidChannel mainchannel;
    char temp[256];

    /* Setup video */

	FrameBuffer[0]=_MemAlloc(SCREEN_WIDTH*SCREEN_HEIGHT*4,512,kMemSDRAM);
	FrameBuffer[1]=_MemAlloc(SCREEN_WIDTH*SCREEN_HEIGHT*4,512,kMemSDRAM);

 	display.dispwidth = SCREEN_WIDTH;
	display.dispheight = SCREEN_HEIGHT;
	display.bordcolor=0x20100000;
	display.progressive=0;
	for(i=0;i<6;i++)
		display.reserved[i]=0;
	
	mainchannel.dmaflags=DMAFLAGS;
	mainchannel.base=FrameBuffer[0];
	mainchannel.dest_xoff = -1;
	mainchannel.dest_yoff = -1;
	mainchannel.dest_width = 720;
	mainchannel.dest_height = 480;
	mainchannel.src_xoff = 0;
	mainchannel.src_yoff = 0;
	mainchannel.src_width = SCREEN_WIDTH;
	mainchannel.src_height = SCREEN_HEIGHT;
	mainchannel.clut_select=0;
	mainchannel.alpha=0;
	mainchannel.vfilter=VID_VFILTER_2TAP;
	mainchannel.hfilter=VID_HFILTER_4TAP;
	for(i=0;i<5;i++)
		mainchannel.reserved[i]=0;
   
    InitTerminalX(0,(int)FrameBuffer[0],SCREEN_WIDTH, SCREEN_HEIGHT, DMAFLAGS, kBlack);                                                              
    _VidConfig ( &display, &mainchannel, 0L, 0L); 

    /* Use MPEs 0,1 and 2 for rendering */
    SPRInit(0,2,16);

    /* Set to the second framebuffer */
    SPRSetDestScreen(FrameBuffer[1], DMAFLAGS,  0,  0,  359,  239, kBlack);
    
    /* Install the TGA image */
    SPRInstallTGAImage(SpriteImage, 1, &img, 0xf0f0ee00);

    /* Create a few sprites */
    sprite=SPRCreateSprite(&img,1,1,26,26);
    sprite2=SPRCreateSprite(&img,28,1,26,26);
    sprite3=SPRCreateSprite(&img,55,1,26,26);
    sprite4=SPRCloneSprite(sprite);
    sprite5=SPRCreateSprite(&img,0,0,128,240);
    
    /* Add sprites to display list*/    
#if 0
    SPRAddSprite(sprite, 180, 120, 0, 0x10000, 0x10000, 0x40000000 | kSpriteInterpolatedTrans, kBlack, 1);
    SPRAddSprite(sprite2, 180, 120, 0, 0x8000, 0x8000, 0x40000000 | kSpriteInterpolatedTrans, kBlack, 2);
    SPRAddSprite(sprite3, 80, 80, 0, 0x20000, 0x20000, 0x40000000 | kSpriteInterpolatedTrans, kBlack, 0);
    SPRAddSprite(sprite4, 260, 180, 0, 0x20000, 0x20000, 0x40000000 | kSpriteInterpolated, kYellow, 3);
#endif
    SPRAddSprite(sprite5, 130, 120, 0, 0x10000, 0x10000, 0x40000002, kYellow, 3);
    
#if 1
    SPRSetDestScreen(FrameBuffer[0], DMAFLAGS,  0,  0,  359,  239, kBlack);
    _VidChangeBase(VID_CHANNEL_MAIN,DMAFLAGS,FrameBuffer[0]);
    b=_TimeElapsed(0,0);
    for(a=0;a<1000;a++)
        SPRDraw(1,1);
    b=_TimeElapsed(0,0)-b;
    sprintf(temp,"%d ms = %d kpps",b,(128*240)*1000/(b));
    Print(temp,kWhite,kBlack);
    for(;;);
#endif

    angle=angle2=0;
    scale=0x8000;
    f=0;
    x=180;
    y=120;
    ix=2;
    iy=-1;
    ia=0x0100;
    c=_VidSync(-1)+60;
    sprintf(temp,"%d fps",f);
    b=1;
    for(;;)
    {
        SPRSetDestScreen(FrameBuffer[b], DMAFLAGS,  0,  0,  359,  239, kBlack);
     /* Process display list */   
        SPRDraw(1,0);
     
    /* Mess around with some sprite parameters */   
        
        SPRSetSpriteXY(sprite,x,y);
        x+=ix;
        if (x>=320 || x<=40) {
            ix=-ix;
            ia=-ia;
        }
        y+=iy;
        if (y>=200 || y<=40) {
            iy=-iy;
            ia=-ia;
        }
        SPRWait();

        SPRSetSpriteRotation(sprite,angle);
        SPRSetSpriteRotation(sprite3,angle2);
        angle+=ia;
        angle2+=0x0800;
        SPRSetSpriteScale(sprite2,scale,scale);
        scale+=0x0400;
        if (scale==0x00040000)
            scale=0x8000;
        
        /* print FPS */   
        
        SetScreenBase((int)FrameBuffer[b]);
        PrintStatus(temp,kWhite,kBlack);
        
        /* toggle frambuffers */   

        _VidChangeBase(VID_CHANNEL_MAIN,DMAFLAGS,FrameBuffer[b]);
         b^=1;

        /* calc FPS */   
         
         a=_VidSync(0);
         f++;

        if (a>=c) {
            c=a+60;
            sprintf(temp,"%d fps",f);
            f=0;
        }

    }

}
